import java.awt.*;
import java.awt.geom.*;

/**
 * The class SnakeSegment is the body of the snake.
 *
 * @author Jason Petty
 * @version 1.0
 */
public class SnakeSegment extends Sprite
{
    // instance variables

    /**
     * Constructor for objects of class SnakeSegment
     */
    public SnakeSegment(int x, int y, Color color)
    {
        // initialise instance variables
        buildSprite(x, y, color);
   
    }

    public void buildSprite(int x, int y, Color color)
    {
        Shape sprite = new Ellipse2D.Float( x, y, 10, 10);
        initializeSprite(sprite, color, x, y);
    }
    
    public void updateSprite(int x, int y)
    {
        if ( getShape() != null )
        {
            Color color = getColor();
            buildSprite(x,y, color);
        }
    }
    
    public void moveSprite(String direction, int bounds)
    {

    }
    
    public void moveSprite(String direction, int bounds, int head_x, int head_y)
    {
        if (direction == "east")
        {
            head_x = head_x+10;
            if ( head_x > GameView.SCREEN_RIGHT)
            {
                head_x = GameView.SCREEN_LEFT;
            }
            updateSprite(head_x,head_y);
        }
        else if ( direction == "south" )
        {
            head_y = head_y+10;
            if ( head_y > GameView.SCREEN_BOTTOM)
            {
                head_y = GameView.SCREEN_TOP;
            }
            updateSprite(head_x,head_y); 
        }
        else if ( direction == "north" )
        {
            head_y = head_y-10;
            if ( head_y < GameView.SCREEN_TOP)
            {
                head_y = GameView.SCREEN_BOTTOM;
            }
            updateSprite(head_x,head_y); 
        }
        else if ( direction == "west" )
        {
            head_x = head_x-10;
            if ( head_x < GameView.SCREEN_LEFT)
            {
                head_x = GameView.SCREEN_RIGHT;
            }
            updateSprite(head_x,head_y); 
        }
            
    }
    
}
