import java.awt.*;

/**
 * The abstract class Sprite is a template to make sprites using SimpleGame
 * g2d game library.
 *
 * @author Jason Petty
 * @version 1.0
 */
abstract class Sprite extends SimpleGame
{
    // instance variables
    private Shape sprite;
    private Color color;
    private int x;
    private int y;
    private boolean dead;
    
    public void initializeSprite(Shape sprite, Color color, int x, int y)
    {
        this.sprite = sprite;
        this.color = color;
        this.x = x;
        this.y = y;
        this.dead = false;
    }
    
    abstract void buildSprite(int x, int y, Color color);
    abstract void updateSprite(int x, int y);
    abstract void moveSprite(String direction, int bounds);
    
    public Color getColor()
    {
        return this.color;
    }
    
    public Shape getShape()
    {
        return this.sprite;
    }
    
    public int getX()
    {
        return this.x;
    }
    
    public int getY()
    {
        return this.y;
    }
    
    public void isDead(boolean value)
    {
        this.dead = value;
    }
    public boolean isDead()
    {
        return this.dead;
    }
}
