import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Queue;
import java.util.LinkedList;

/**
 * The class SnakeView is used to display the game to the player.
 *
 * @author Jason Petty
 * @version 1.0
 */
public class SnakeView extends GameView
{
    // instance variables
    private int segments;
    private String speedSetting;
    private String gameOverText;
    private boolean gameOver;

    /**
     * Constructor for objects of class SnakeView
     */
    public SnakeView()
    {
        // initialise instance variables
        setGamePanel(new GamePanel());   
        segments = 0;
        speedSetting = "Slow";
        gameOverText = "Better Luck Next Time! Game Over!";
        gameOver = false;
    }
    
    public void setGameOver()
    {
        gameOver = true;
    }
    public void resetGameOver()
    {
        gameOver = false;
    }
    
    public void setSegments(int value)
    {
        this.segments = value;
    }
    public void resetSegments()
    {
        this.segments = 0;
    }
    public void setSpeed(String value)
    {
        this.speedSetting = value;
    }
    public void resetSpeed()
    {
        this.speedSetting = "Slow";
    }
    
    class GamePanel extends JPanel
    {
        // This paint Component is meant to be overridden to add your specific game code.
        public void paintComponent(Graphics g)
        {
            Graphics2D g2d = (Graphics2D)g;
            g2d.setBackground(Color.black);
            g2d.clearRect(0,0,this.getWidth(), this.getHeight());
            
            g2d.setColor(Color.green);
            g2d.drawString( ("Score: "+ score), 45,50);
            g2d.drawString( ("Snake Size: " + segments), 375, 50);
            g2d.drawString( ("Snake Speed: " + speedSetting), 185, 50);
            g2d.drawString( "Directions: Use the arrow keys to move the snake and eat as many apples as you can.",12, 620);
            g2d.drawString( "press (R) to restart.",200, 650);
            
            if ( gameOver == true )
            {
                g2d.setColor(Color.red);
                g2d.drawString(gameOverText, 143, 300);
            }
                       
            while ( !drawQueue.isEmpty() )
            {
                // Put Draw Code Here by casting the simpleGame object to the appropriate object and
                // drawing the objects out of the cue.
                Sprite sprite = (Sprite)drawQueue.remove();
                g2d.setColor(sprite.getColor());
                g2d.draw(sprite.getShape());
                if ( sprite instanceof Apple )
                {
                    g2d.fill(sprite.getShape());
                    
                }
            }
            
            // This area is used to draw anything else you want to draw that is not queued up.
            


        }
    }

}
